#include <iostream>

using namespace std;

int main()
{
    int n, q;
    cin>>n>>q;
    float Direktan_napad[n], Otrovan_napad[n], Hp[q];
    for(int i=0;i<n;i++)
    {
        cin>>Direktan_napad[i]>>Otrovan_napad[i];
    }
    for(int i=0;i<q;i++)
    {
        cin>>Hp[i];
    }
    for(int i=0;i<q;i++)
    {
        float otrov_po_potezu=0, s=0, hp_tren=Hp[i];
        int potezi=0;
        bool moguce=true;
        for(int j=0;j<n;j++)
        {
            s+=Direktan_napad[j];
            if(s>hp_tren)
            {
                potezi=j;
                j=n;
            }
        }
        if(potezi==0)
        {
            potezi=n;
            moguce=false;
        }
        for(int j=0;j<n;j++)
        {
            if(Otrovan_napad[j]*(potezi)>Direktan_napad[j])
            {
                otrov_po_potezu=otrov_po_potezu+Otrovan_napad[j];
                float ostatak=Otrovan_napad[j]*(potezi-j);
                unsigned pointer=potezi-1;
                while((ostatak>max(Otrovan_napad[pointer], Direktan_napad[pointer])))
                {
                    ostatak=ostatak-max(Otrovan_napad[pointer], Direktan_napad[pointer--]);
                    if(pointer==0)
                        break;
                    if(moguce)
                    {
                        potezi--;
                    }
                }
            }
            else
            {
                Hp[i]-=Direktan_napad[j];
            }
            Hp[i]=Hp[i]-otrov_po_potezu;
            if(Hp[i]<=0)
            {
                potezi=j+1;
                j=n;
            }
            for(int k=j;k<n;k++)
            {
                s+=Direktan_napad[k];
                if(s>hp_tren)
                {
                    potezi=k;
                    k=n;
                }
            }
            if(potezi==0)
            {
                potezi=n;
                moguce=false;
            }
        }
        if(Hp[i]>0)
            cout<<-1<<endl;
        else
            cout<<potezi<<endl;
    }
    return 0;
}